#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "mixmaster.h"
#include "qsnymver.h"
#include "nymwizdlgs.h"
#include "nymdecdlgs.h"
#include "fingerdlgs.h"
#include "nymrepdlgs.h"
#include "nymrptsdlgs.h"
#include "nymregistrydlgs.h"
#include "headman.h"
#include "pgpfiles.h"
#include "nymkeychngdlgs.h"

USERES("QSnym\QSnym.res");
USEUNIT("QSnym\QSnymVer.cpp");
USEFORM("QSnym\NymEditDlgs.cpp", NymEditDlg);
USEFORM("QSnym\NymRemsDlgs.cpp", NymRemsDlg);
USEFORM("QSnym\NymRepDlgs.cpp", NymRepDlg);
USEFORM("QSnym\NymDecDlgs.cpp", NymDecDlg);
USEFORM("QSnym\NymWizDlgs.cpp", NymWizDlg);
USEFORM("QSnym\FingerDlgs.cpp", FingerDlg);
USEFORM("QSnym\NymIntrDlgs.cpp", NymIntrDlg);
USEFORM("QSnym\NymRestPgpDlgs.cpp", NymRestPgpDlg);
USEFORM("QSnym\NymCnclDlgs.cpp", NymCnclDlg);
USEFORM("QSnym\NymPrevBlkDlgs.cpp", NymPrevBlkDlg);
USEFORM("QSnym\NymRptsDlgs.cpp", NymRptsDlg);
USEFORM("QSnym\NymRegistryDlgs.cpp", NymRegistryDlg);
USEFORM("QSnym\NymNewDlgs.cpp", NymNewDlg);
USEFORM("QSnym\NymMsgDlgs.cpp", NymMsgDlg);
USEFORM("QSnym\NymKeyChngDlgs.cpp", NymKeyChngDlg);
USEFORM("QSnym\MixDlgs.cpp", MixForm);
USEFORM("QSnym\HelpDlgs.cpp", HelpDlg);
USEFORM("QSnym\View.cpp", ViewDlg);
USEFORM("QSnym\MsgBoxDlgs.cpp", MsgBoxDialog);
USEFORM("QSnym\NymDhDssDlgs.cpp", NymDhDssDlg);
USEFORM("QSnym\NymRSABitsDlgs.cpp", NymRSABitsDlg);
USEFORM("QSnym\NymDeleteDlgs.cpp", NymDeleteDlg);
USEFORM("QSnym\BrokeChnDlgs.cpp", BrokeChnDlg);
USEFORM("QSnym\WipeDlgs.cpp", WipeDlg);
USEUNIT("QSnym\PGPbuffers.cpp");
USEUNIT("QSnym\nymmail.cpp");
USEUNIT("QSnym\Global.cpp");
USEUNIT("QSnym\FileMan.cpp");
USEUNIT("QSnym\Mixmaster.cpp");
USEUNIT("QSnym\HeadMan.cpp");
USEUNIT("QSnym\PgpFiles.cpp");
USEUNIT("QSnym\pgpmail.cpp");
USEUNIT("QSnym\Cyberpunk.cpp");
USEUNIT("QSnym\tbuffer.cpp");
USEFORM("QSnym\NymRepWizs.cpp", NymRepWiz);
USEFORM("QSnym\NymLegWins.cpp", NymLegWin);
USEFORM("QSnym\NymProbDlgs.cpp", NymProbDlg);
USEFORM("QSnym\NymRBRemDlgs.cpp", NymRBRemDlg);
USEFORM("QSnym\NymLateDlgs.cpp", NymLateDlg);
USEFORM("QSnym\NymEkxDlgs.cpp", NymEkxDlg);
USEFORM("QSnym\Unit1.cpp", Form1);
//---------------------------------------------------------------------------
extern "C" {
__declspec(dllexport) void __fastcall NymInit(HINSTANCE HMixLib,
   HINSTANCE HSSLLib, HWND AppHandle);
__declspec(dllexport) void __fastcall NymShutDown();
__declspec(dllexport) char*__fastcall GetNymLibName();
__declspec(dllexport) char*__fastcall GetNymLibVersion();
__declspec(dllexport) bool __fastcall RunNymWizard(TForm *Owner);
__declspec(dllexport) void __fastcall RunNymReports(TForm *Owner);
__declspec(dllexport) char*__fastcall RunNymRegistry(TForm *owner);
__declspec(dllexport) char*__fastcall RunNymPGPKeyChange(TForm *Owner, char *oldkeyid);
__declspec(dllexport) char*__fastcall DecryptNymMessage(TForm *Owner, char *msg, int &errcode);
__declspec(dllexport) char*__fastcall GenerateReplyBlocks(TForm *Owner,
   char *Blocks, bool preview);
__declspec(dllexport) void __fastcall RunFinger(TForm *Owner);
  // create config message
__declspec(dllexport) bool __fastcall CreateConfigMessage(TForm *Owner,
   char *NymAddress, char *Profile, char *orgProfile,
   char *templatename, bool preview);
  // create delete message
__declspec(dllexport) bool __fastcall CreateDeleteMessage(TForm *Owner,
   char *NymAddress, char *Profile, char *orgProfile,
   char *templatename);
__declspec(dllexport) bool __fastcall CreateKeyChangeMessage(TForm *Owner,
   char *NymAddress, char *Profile,char *orgProfile,
   char *templatename, char *newkeyid8);
  // create command message
__declspec(dllexport) bool __fastcall CreateCommandMessage(TForm *Owner,
   char *NymAddress, char *Profile, char *orgProfile,
   char *templatename);
}
//---------------------------------------------------------------------------
char *retbuf=NULL;
const bool noclear = false;
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
   return 1;
}
//---------------------------------------------------------------------------
void __fastcall NymInit(HINSTANCE HMixLib, HINSTANCE HSSLLib, HWND AppHandle)
{
   hMixLib=HMixLib; hSSLLib=HSSLLib;
   Application->Handle=AppHandle;
}
//---------------------------------------------------------------------------
void __fastcall NymShutDown()
{
   if (retbuf) delete retbuf;
}
//---------------------------------------------------------------------------
char*__fastcall GetNymLibVersion()
{
   return ReleaseVer.c_str();
}
//---------------------------------------------------------------------------
char*__fastcall GetNymLibName()
{
   return AppName.c_str();
}
//---------------------------------------------------------------------------

char*__fastcall DecryptNymMessage(TForm *Owner, char *message, int &errcode)
{
   TStringList *msg = new TStringList();
   msg->SetText(message);
   if (retbuf) delete retbuf; retbuf = NULL;
   TNymDecDlg *NymDecDlg = new TNymDecDlg(Owner);
   if (NymDecDlg->Decrypt(msg))
   {
      retbuf = new char[msg->Text.Length()+1];
      strcpy(retbuf,msg->Text.c_str());
   }
   errcode = NymDecDlg->errcode;
   delete NymDecDlg;
   return retbuf;
}
//---------------------------------------------------------------------------

bool __fastcall RunNymWizard(TForm *Owner)
{
   bool run=false;
   NymWizDlg = new TNymWizDlg(Owner);
   CenterDialog(NymWizDlg,Owner);
   NymWizDlg->ShowModal();
   if (NymWizDlg->ModalResult==mrOk)
      run = true;
   delete NymWizDlg;
   return run;
}
//---------------------------------------------------------------------------

char* __fastcall RunNymRegistry(TForm *Owner)
{
   AnsiString nymkey;
   NymRegistryDlg = new TNymRegistryDlg(Owner);
   NymRegistryDlg->ShowModal();
   if (NymRegistryDlg->ModalResult==mrOk && !NymRegistryDlg->chosenkey.IsEmpty())
      nymkey = NymRegistryDlg->chosenkey;
   delete NymRegistryDlg;
   if (retbuf) delete retbuf;
   retbuf = new char[nymkey.Length()+1];
   strcpy(retbuf,nymkey.c_str());
   return retbuf;
}
//---------------------------------------------------------------------------

void __fastcall RunFinger(TForm *Owner)
{
   FingerDlg = new TFingerDlg(Owner);
   CenterDialog(FingerDlg,Owner);
   FingerDlg->ShowModal();
   delete FingerDlg;
}
//---------------------------------------------------------------------------

void __fastcall RunNymReports(TForm *Owner)
{
   NymRptsDlg = new TNymRptsDlg(Owner);
   NymRptsDlg->ShowModal();
   delete NymRptsDlg;
}
//---------------------------------------------------------------------------

char* __fastcall GenerateReplyBlocks(TForm *Owner, char *Blocks, bool Preview)
{
   if (retbuf) delete retbuf; retbuf = NULL;
   TStringList *blocks = new TStringList();
   TStringList *compiled = new TStringList();
   blocks->SetText(Blocks);
   NymRepDlg = new TNymRepDlg(Owner,blocks,Preview);
   NymRepDlg->ShowModal();
   int mrResult = NymRepDlg->ModalResult;
   if (mrResult==mrOk)
   {
      compiled->Text = NymRepDlg->compiled->Text;
      retbuf = new char[compiled->Text.Length()+1];
      strcpy(retbuf,compiled->Text.c_str());
   }
   delete NymRepDlg;
   delete compiled;
   delete blocks;
   return retbuf;
}
//---------------------------------------------------------------------------

char*__fastcall RunNymPGPKeyChange(TForm *Owner, char *oldkeyid)
{
   AnsiString newkeyid = RunNymKeyChange(Owner,s(oldkeyid));
   if (newkeyid.IsEmpty()) return "";
   if (retbuf) delete retbuf;
   retbuf = new char[newkeyid.Length()+1];
   strcpy(retbuf,newkeyid.c_str());
   return retbuf;
}
//---------------------------------------------------------------------------

bool __fastcall CutMessageAtCutmarks(TStrings *msg)
{
   bool cut = false;
   if (msg->Text.Pos("\r\n"+CutMarks+"\r\n"))
   {
      while (msg->Count)
      {
         AnsiString line = msg->Strings[msg->Count-1];
         msg->Delete(msg->Count-1);
         if (line.TrimRight()==CutMarks) break;
      }
      cut = true;
   }
   return cut;
}
//---------------------------------------------------------------------------

AnsiString __fastcall GetProfileItem(AnsiString name, TStrings *profile)
{
   AnsiString line,item;
   for (int i=0; i<profile->Count; i++)
   {
      line = profile->Strings[i];
      if (line.Pos(name)==1)
      {
         item = line.SubString(name.Length()+1,256);
         break;
      }
   }
   return item;
}
//---------------------------------------------------------------------------

bool __fastcall LoadReplyBlocks(TStrings *blocks, TStrings *profile)
{
   AnsiString line;
   bool inblock=false;
   for (int i=0; i<profile->Count; i++)
   {
      line = profile->Strings[i];
      if (line.Pos("Reply-Block:")==1) inblock = true;
      if (line.Pos("-----BEGIN PGP")==1) break;
      if (line.Pos("Reply-Block:")==1 &&
         blocks->Count && blocks->Strings[blocks->Count-1]!="")
            blocks->Add("");
      if (inblock) blocks->Add(line);
   }
   return blocks->Count;
}
//---------------------------------------------------------------------------

bool __fastcall AddHeaderToMessage(AnsiString &header, TStrings *msg)
{
   int idx; AnsiString hdr=header.SubString(1,header.Pos(":"));
   if (hdr.IsEmpty()) return false;

   THeaderManager *headers = new THeaderManager(msg);
   if ((idx=headers->Delete(hdr))>=0) msg->Insert(idx,header);
   else msg->Insert(headers->Eoh(),header);
   delete headers;
   return true;
}
//---------------------------------------------------------------------------

bool __fastcall ReplyBlocksFailInitialScan(TStrings *blocks, TStrings *profile)
{
   if (!LoadReplyBlocks(blocks,profile)) return true;
   // validity checks
   return false;
}
//---------------------------------------------------------------------------

bool __fastcall CreateConfigMessage(TForm *Owner, char* NymAddress, char *Profile,
   char *orgProfile, char *templatename, bool preview)
{
   AnsiString tname,temp,line,rcphdr,pgphdr,idtext8,item,namstr,keystr,keyorg,
      cmdstr,shrt,addr,nymaddr=NymAddress;
   TPGPbuffer *key,*pubkeys,*cpkkeys;

   TStringList *profile = new TStringList();
   TStringList *orgprofile = new TStringList();
   profile->SetText(Profile);
   orgprofile->SetText(orgProfile);
   tname = templatename;
   if (tname.IsEmpty()) return false;

   TStringList *blocks = new TStringList();
   if (ReplyBlocksFailInitialScan(blocks,profile))
   {
      delete orgprofile;
      delete profile;
      delete blocks;
      return false;
   }
   blocks->SetText(
      GenerateReplyBlocks((TForm*)Owner,blocks->Text.c_str(),preview)
   );
   if (blocks->Text.Length()==0)
   {
      delete orgprofile;
      delete profile;
      delete blocks;
      return false;
   }

   TStringList *msg = new TStringList();
   shrt = GetToken(0,nymaddr,"@");
   addr = GetToken(1,nymaddr,"@");
   namstr = GetProfileItem("Name: ",profile);
   keystr = GetProfileItem("PgpKey: ",profile);
   keyorg = GetProfileItem("PgpKey: ",orgprofile);
   cmdstr = GetProfileItem("Commands: ",profile);

   key = new TPGPbuffer();
   pubkeys = new TPGPbuffer(PgpPublicRing());
   cpkkeys = new TPGPbuffer(PgpRemailRing());
   pubkeys->get(keyorg.SubString(1,10),key); // use original key to sign
   idtext8 = cpkkeys->getidtext8(addr);
   pgphdr = "Pgp: sign=0x"+key->idtext8+"; encrypt=0x"+idtext8;
   rcphdr = "To: config@"+addr;
   pubkeys->get(keystr.SubString(1,10),key); // put current key in message

   // build message from headers down;
   GetAppData(msg,tname);
   CutMessageAtCutmarks(msg); TrimNullsAfter(msg);
   //msg->Insert(0,NymConfigHdr+nymaddr);
   AddHeaderToMessage(pgphdr,msg);
   AddHeaderToMessage(rcphdr,msg);
   msg->Add("");
   msg->Add("Config:");
   msg->Add("From: "+shrt);
   msg->Add("Nym-Commands: create? "+cmdstr+" name=\""+namstr+"\"");
   msg->Add("Public-Key:");
   key->export(msg,noclear);
   msg->AddStrings(blocks);
   msg->Add("~~");

   delete blocks;
   delete cpkkeys;
   delete pubkeys;
   delete key;

   Owner->Perform(WM_OPENNYMMESSAGE,0,(LPARAM)msg->Text.c_str());
 //PutNymMessageOnDesktop(AppMainForm,msg);
   delete msg;
   delete orgprofile;
   delete profile;
   return true;
}
//---------------------------------------------------------------------------

bool __fastcall CreateDeleteMessage(TForm *Owner, char *NymAddress, char *Profile,
   char *orgProfile, char *templatename)
{
   AnsiString tname,temp,line,rcphdr,pgphdr,idtext8,item,namstr,keystr,keyorg,
      cmdstr,shrt,addr,nymaddr=NymAddress;
   TPGPbuffer *key,*pubkeys,*cpkkeys;

   TStringList *profile = new TStringList();
   TStringList *orgprofile = new TStringList();
   profile->SetText(Profile);
   orgprofile->SetText(orgProfile);
   tname = templatename;
   if (tname.IsEmpty()) return false;

   TStringList *msg = new TStringList();
   shrt = GetToken(0,nymaddr,"@");
   addr = GetToken(1,nymaddr,"@");
   namstr = GetProfileItem("Name: ",profile);
   keystr = GetProfileItem("PgpKey: ",profile);
   keyorg = GetProfileItem("PgpKey: ",orgprofile);
   cmdstr = GetProfileItem("Commands: ",profile);

   key = new TPGPbuffer();
   pubkeys = new TPGPbuffer(PgpPublicRing());
   cpkkeys = new TPGPbuffer(PgpRemailRing());
   pubkeys->get(keyorg.SubString(1,10),key); // use original key to sign
   idtext8 = cpkkeys->getidtext8(addr);
   pgphdr = "Pgp: sign=0x"+key->idtext8+"; encrypt=0x"+idtext8;
   rcphdr = "To: config@"+addr;

   // build message from headers down;
   GetAppData(msg,tname);
   CutMessageAtCutmarks(msg); TrimNullsAfter(msg);
   AddHeaderToMessage(pgphdr,msg);
   AddHeaderToMessage(rcphdr,msg);
   //msg->Insert(0,NymConfigHdr+nymaddr);
   msg->Add("");
   msg->Add("Config:");
   msg->Add("From: "+shrt);
   msg->Add("Nym-Commands: delete");
   msg->Add("");
   msg->Add("~~");

   delete cpkkeys;
   delete pubkeys;
   delete key;

   Owner->Perform(WM_OPENNYMMESSAGE,0,(LPARAM)msg->Text.c_str());
 //PutNymMessageOnDesktop(AppMainForm,msg);
   delete msg;
   delete orgprofile;
   delete profile;
   return true;
}
//---------------------------------------------------------------------------

bool __fastcall CreateKeyChangeMessage(TForm *Owner, char *NymAddress, char *Profile,
   char *orgProfile, char *templatename, char *newkeyid8)
{
   AnsiString tname,temp,line,rcphdr,pgphdr,idtext8,item,namstr,keystr,keyorg,
      cmdstr,shrt,addr,nymaddr=NymAddress;
   TPGPbuffer *key,*pubkeys,*cpkkeys;

   TStringList *profile = new TStringList();
   TStringList *orgprofile = new TStringList();
   profile->SetText(Profile);
   orgprofile->SetText(orgProfile);
   tname = templatename;
   if (tname.IsEmpty()) return false;

   TStringList *msg = new TStringList();
   shrt = GetToken(0,nymaddr,"@");
   addr = GetToken(1,nymaddr,"@");
   namstr = GetProfileItem("Name: ",profile);
   keystr = GetProfileItem("PgpKey: ",profile);
   keyorg = GetProfileItem("PgpKey: ",orgprofile);
   cmdstr = GetProfileItem("Commands: ",profile);

   key = new TPGPbuffer();
   pubkeys = new TPGPbuffer(PgpPublicRing());
   cpkkeys = new TPGPbuffer(PgpRemailRing());
   pubkeys->get(keyorg.SubString(1,10),key); // use original key to sign
   idtext8 = cpkkeys->getidtext8(addr);
   pgphdr = "Pgp: sign=0x"+key->idtext8+"; encrypt=0x"+idtext8;
   rcphdr = "To: config@"+addr;
   pubkeys->get(newkeyid8,key);

   // build message from headers down;
   GetAppData(msg,tname);
   CutMessageAtCutmarks(msg); TrimNullsAfter(msg);
   AddHeaderToMessage(pgphdr,msg);
   AddHeaderToMessage(rcphdr,msg);
   //msg->Insert(0,NymConfigHdr+nymaddr);
   msg->Add("");
   msg->Add("Config:");
   msg->Add("From: "+shrt);
   msg->Add("Public-Key: ");
   key->export(msg,noclear);
   msg->Add("");
   msg->Add("~~");

   delete cpkkeys;
   delete pubkeys;
   delete key;

   Owner->Perform(WM_OPENNYMMESSAGE,0,(LPARAM)msg->Text.c_str());
 //PutNymMessageOnDesktop(AppMainForm,msg);
   delete msg;
   delete orgprofile;
   delete profile;
   return true;
}
//---------------------------------------------------------------------------

bool __fastcall CreateCommandMessage(TForm *Owner, char *NymAddress, char *Profile,
   char *orgProfile, char *templatename)
{
   AnsiString tname,temp,line,rcphdr,pgphdr,idtext8,item,namstr,keystr,keyorg,
      cmdstr,shrt,addr,nymaddr=NymAddress;
   TPGPbuffer *key,*pubkeys,*cpkkeys;

   TStringList *profile = new TStringList();
   TStringList *orgprofile = new TStringList();
   profile->SetText(Profile);
   orgprofile->SetText(orgProfile);
   tname = templatename;
   if (tname.IsEmpty()) return false;

   TStringList *msg = new TStringList();
   shrt = GetToken(0,nymaddr,"@");
   addr = GetToken(1,nymaddr,"@");
   namstr = GetProfileItem("Name: ",profile);
   keystr = GetProfileItem("PgpKey: ",profile);
   keyorg = GetProfileItem("PgpKey: ",orgprofile);
   cmdstr = GetProfileItem("Commands: ",profile);

   key = new TPGPbuffer();
   pubkeys = new TPGPbuffer(PgpPublicRing());
   cpkkeys = new TPGPbuffer(PgpRemailRing());
   pubkeys->get(keyorg.SubString(1,10),key); // use original key to sign
   idtext8 = cpkkeys->getidtext8(addr);
   pgphdr = "Pgp: sign=0x"+key->idtext8+"; encrypt=0x"+idtext8;
   rcphdr = "To: config@"+addr;

   // build message from headers down;
   GetAppData(msg,tname);
   CutMessageAtCutmarks(msg); TrimNullsAfter(msg);
   AddHeaderToMessage(pgphdr,msg);
   AddHeaderToMessage(rcphdr,msg);
   //msg->Insert(0,NymConfigHdr+nymaddr);
   msg->Add("");
   msg->Add("Config: ");
   msg->Add("From: "+shrt);
   msg->Add("Nym-Commands: create? "+cmdstr+" name=\""+namstr+"\"");
   msg->Add("");
   msg->Add("~~");

   delete cpkkeys;
   delete pubkeys;
   delete key;

   Owner->Perform(WM_OPENNYMMESSAGE,0,(LPARAM)msg->Text.c_str());
 //PutNymMessageOnDesktop(AppMainForm,msg);
   delete msg;
   delete orgprofile;
   delete profile;
   return true;
}
//---------------------------------------------------------------------------
